/*global define,window*/
define([
    'testsuite/qunit',
    'jquery',
    'ep',
    'testsuite/qunit-fixture!./trustbadgelinkgenerator-test',
    'de_epages/trustedshops/ui/trustbadgelinkgenerator'
], function (QUnit, $, ep, fixture, trustbadgelinkgenerator) {

    'use strict';

    QUnit.module('de_epages/trustedshops/ui/trustbadgelinkgenerator', {
        setup: fixture.init,
        teardown: fixture.destroy
    });

    QUnit.test('Check that Trustbadge link gets modified by changing country selected option', 3, function () {

        var TrustbadgeLink = $('#TrustbadgeLink');
        var LangSelector = $('select.CountryCodes');
        var UIControlParameters = {
                trustbadgelink : TrustbadgeLink,
                langselector : LangSelector,
                shopalias : 'X35A8844FD4E62A875C2C9E1C05C39CD4',
                shopsw : 'EPAGES',
                shopswversion : '4.3.2',
                pluginversion : '2.0',
                context : 'trustbadge'
        };

        QUnit.strictEqual(
            TrustbadgeLink.attr('href'),
            "",
            'Trustbadge link reference is empty before loading page'
        );

        trustbadgelinkgenerator(UIControlParameters);
        QUnit.strictEqual(
            TrustbadgeLink.attr('href'),
            "https://www.trustedshops.com/integration/?shop_id=X35A8844FD4E62A875C2C9E1C05C39CD4&backend_language=&shopsw=EPAGES&shopsw_version=4.3.2&plugin_version=2.0&context=trustbadge",
            'Trustbadge link is set up with no language set'
        );

        LangSelector.val('en');
        trustbadgelinkgenerator(UIControlParameters);
        QUnit.strictEqual(
            TrustbadgeLink.attr('href'),
            "https://www.trustedshops.com/integration/?shop_id=X35A8844FD4E62A875C2C9E1C05C39CD4&backend_language=en&shopsw=EPAGES&shopsw_version=4.3.2&plugin_version=2.0&context=trustbadge",
            'Trustbadge link is set up with english (en) language set'
        );
    });
});